package dev.pfaff.recipe_nope.mixin;

import dev.pfaff.recipe_nope.RecipeNope;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.game.ClientboundRecipePacket;
import net.minecraft.stats.RecipeBookSettings;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.Redirect;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.List;
import java.util.function.Function;

@Mixin(ClientboundRecipePacket.class)
public abstract class UnlockRecipesS2CPacketMixin {
	@Redirect(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/network/FriendlyByteBuf;readEnum(Ljava/lang/Class;)Ljava/lang/Enum;"))
	private <T extends Enum<T>> T init$skipReadAction(FriendlyByteBuf instance, Class<T> enumClass) {
		return null;
	}

	@Redirect(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/stats/RecipeBookSettings;read(Lnet/minecraft/network/FriendlyByteBuf;)Lnet/minecraft/stats/RecipeBookSettings;"))
	private RecipeBookSettings init$skipReadOptions(FriendlyByteBuf buf) {
		return null;
	}

	@Redirect(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/network/FriendlyByteBuf;readList(Ljava/util/function/Function;)Ljava/util/List;"))
	private <T> List<T> init$skipReadList(FriendlyByteBuf instance, Function<FriendlyByteBuf, T> entryParser) {
		return null;
	}

	@Inject(method = "<init>(Lnet/minecraft/network/FriendlyByteBuf;)V", at = @At(value = "TAIL"))
	private void init$noRead(FriendlyByteBuf buf, CallbackInfo ci) {
		buf.readerIndex(buf.writerIndex());
	}

	@Overwrite
	public void write(FriendlyByteBuf buf) {
		throw RecipeNope.unsupported();
	}

	@Overwrite
	public void handle(ClientGamePacketListener clientPlayPacketListener) {
	}
}
